{* Replacement for the DDEClientConv-Component of Delphi 5 
(maybe D4 too, you'll have to test that)

Inprise has NO property for DDE-timeout. They hardcoded it as 10 seconds.
This component implements the timeout for DDE-requests. 
The timout-property is RUNTIME-ONLY! Therefore you'll have to set this 
timeout befor the first DDE-request by setting 

DDEClientConv_T.Timeout :=XXXXX;   //where DDEClientConv_T is your components name
						and XXXXX is the time in milliseconds 
The Settings in the Object inspector don't affect the program :-(
Installation by Component|Install Component ......
after that you'll find the icon rightmost on the system-tab.

This component is freeware and provided 'as is' without ANY warranty 
or liability for damages it may cause to your application or your system.

you reach me for questions or hints at rainer.schuetz@usa.net *}

unit DdeClientConv_T;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DdeMan, DDEML, StdCtrls;

type
  TDdeClientConv_T = class(TDdeClientConv)
  private
    FTimeOut: cardinal;
    procedure setTimeOut(NewTimeOut: cardinal);
    { Private declarations }
  protected
    { Protected declarations }
  public
    procedure create (AOwner: TComponent);
    procedure destroy;
    function PasteLink: Boolean;
    function SetLink(const Service, Topic: string): Boolean;
    procedure CloseLink;
    function OpenLink: Boolean;
    function StartAdvise: Boolean;
    function PokeDataLines(const Item: string; Data: TStrings): Boolean;
    function PokeData(const Item: string; Data: PChar): Boolean;
    function ExecuteMacroLines(Cmd: TStrings; waitFlg: Boolean): Boolean;
    function ExecuteMacro(Cmd: PChar; waitFlg: Boolean): Boolean;
    function RequestData(const Item: string; const TimeOut: cardinal): PChar; overload;

    { Public declarations }
  published
    property TimeOut: cardinal read FTimeOut write SetTimeOut default 10000;
    { Published declarations }
  end;

procedure Register;

implementation

function TDdeClientConv_T.RequestData(const Item: string; const TimeOut: cardinal): PChar;
var
  hData: HDDEData;
  ddeRslt: LongInt;
  hItem: HSZ;
  pData: Pointer;
  Len: Integer;
begin
  Result := nil;
  if (TDdeClientConv(Self).Conv = 0) or TDdeClientConv(Self).WaitStat then Exit;
  hItem := DdeCreateStringHandle(ddeMgr.DdeInstId, PChar(Item), CP_WINANSI);
  if hItem <> 0 then
  begin
    hData := DdeClientTransaction(nil, 0, TDdeClientConv(Self).Conv, hItem, TDdeClientConv(Self).DdeFmt,
      XTYP_REQUEST, TimeOut, @ddeRslt);
    DdeFreeStringHandle(ddeMgr.DdeInstId, hItem);
    if hData <> 0 then
    try
      pData := DdeAccessData(hData, @Len);
      if pData <> nil then
      try
        Result := StrAlloc(Len + 1);
        Move(pData^, Result^, len);    // data is binary, may contain nulls
        Result[len] := #0;
      finally
        DdeUnaccessData(hData);
      end;
    finally
      DdeFreeDataHandle(hData);
    end;
  end;
end;

procedure TDdeClientConv_T.SetTimeOut(NewTimeOut: Cardinal);
begin
  if FTimeOut <> NewTimeOut then
  begin
    FTimeOut := NewTimeOut;
  end;
end;

procedure TDdeClientConv_T.create (AOwner: TComponent);
begin
  TDdeClientConv(Self).Create(AOwner);
end;

procedure TDdeClientConv_T.destroy;
begin
  TDdeClientConv(Self).destroy;
end;

function TDdeClientConv_T.PasteLink: Boolean;
begin
  Result := TDdeClientConv(Self).Pastelink;
end;

function TDdeClientConv_T.OpenLink: Boolean;
begin
  Result := TDdeClientConv(Self).Openlink;
end;

function TDdeClientConv_T.SetLink(const Service, Topic: string): Boolean;
begin
  Result := TDdeClientConv(Self).Setlink (Service, Topic);
end;

procedure TDdeClientConv_T.CloseLink;
begin
  TDdeClientConv(Self).Closelink;
end;

function TDdeClientConv_T.StartAdvise: Boolean;
begin
  Result := TDdeClientConv(Self).StartAdvise;
end;

function TDdeClientConv_T.PokeDataLines(const Item: string; Data: TStrings): Boolean;
begin
  Result := TDdeClientConv(Self).PokeDataLines(Item, Data);
end;

function TDdeClientConv_T.PokeData(const Item: string; Data: PChar): Boolean;
begin
  Result := TDdeClientConv(Self).PokeData(Item, Data);
end;

function TDdeClientConv_T.ExecuteMacroLines(Cmd: TStrings; waitFlg: Boolean): Boolean;
begin
  Result := TDdeClientConv(Self).ExecuteMacroLines(Cmd, WaitFlg);
end;

function TDdeClientConv_T.ExecuteMacro(Cmd: PChar; waitFlg: Boolean): Boolean;
begin
  Result := TDdeClientConv(Self).ExecuteMacro(Cmd, WaitFlg);
end;


procedure Register;
begin
  RegisterComponents('System', [TDdeClientConv_T]);
end;

end.
