// #define STRICT
// #define	LIB

#include <windows.h>
#include <ddeml.h>
#include <stdio.h>


//-------------------------------------------------------------------------
//  some global stuff
//-------------------------------------------------------------------------
HINSTANCE hInst= 0L;
HWND hwMain= NULL;

char *AppName= "ZOC DDE SAMPLE";
char *WndTitle= "ZOC DDE SAMPLE";
char *ClassName= "ZOC-DDE-Window";

HCONV Conversation= 0;
DWORD DdeInst= 0;


//-------------------------------------------------------------------------
//  prototypes
//-------------------------------------------------------------------------
int	_stdcall WinMain(HINSTANCE, HINSTANCE, LPSTR, int);
LONG _stdcall MainWndProc(HWND, UINT, WORD, LONG);
HDDEDATA CALLBACK DdeCallback(UINT, UINT, HCONV, HSZ, HSZ, HDDEDATA, DWORD, DWORD);
void InitDdeSession(void);
void ZocCommand(char *);
void ZocFunction(char *);
void EndDdeSession(void);



////////////////////////////////////////////////////////////////////////////
//                                                                        //
// WinMain()															  //
//                                                                        //
////////////////////////////////////////////////////////////////////////////

int	_stdcall 
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, 
			LPSTR lpszCmdLine, int nCmdShow) 
{
	MSG	Message;
	WNDCLASS WndClass;

	hInst= hInstance;

	if (!hPrevInstance) {
		WndClass.lpszClassName= ClassName;
		WndClass.hInstance= hInst;
		WndClass.lpfnWndProc= (WNDPROC)MainWndProc;
		WndClass.style= CS_HREDRAW | CS_VREDRAW;
		WndClass.lpszMenuName= MAKEINTRESOURCE(100);
		WndClass.hCursor= LoadCursor(NULL, IDC_ARROW);
		WndClass.hIcon= NULL; 
		WndClass.hbrBackground= (HBRUSH)GetStockObject(WHITE_BRUSH);
		WndClass.cbClsExtra= 0;
		WndClass.cbWndExtra= 0;

		if (!RegisterClass(&WndClass))
			return 0;
	}

	hwMain= CreateWindow((LPSTR)ClassName,
								 (LPSTR)WndTitle,
								 WS_OVERLAPPEDWINDOW,
								 CW_USEDEFAULT, CW_USEDEFAULT,
								 CW_USEDEFAULT, CW_USEDEFAULT,
								 NULL, NULL, hInst, NULL);

	if (!hwMain)
		return 0;

	// open main window

	ShowWindow(hwMain, SW_NORMAL);
	UpdateWindow(hwMain);

	// connect to ZOC for a DDE session
	InitDdeSession();

	while (GetMessage((LPMSG)&Message, NULL, 0, 0)) {
		TranslateMessage((LPMSG)&Message);
		DispatchMessage((LPMSG)&Message);
	}

	// DDE-Sitzung beenden
	EndDdeSession();

	return Message.wParam;
}



////////////////////////////////////////////////////////////////////////////
//                                                                        //
// Our friendly window procedure                                          //
//                                                                        //
////////////////////////////////////////////////////////////////////////////
LONG _stdcall 
MainWndProc(HWND hwnd, UINT msg, WORD wp, LONG lp) 
{
	long rc= 1;

	switch (msg) {

		case WM_COMMAND: 
				switch (wp) {

					case 101:
						ZocCommand("ZocNotify('Hello World!')");
						break;

					case 102:
						ZocCommand("ZocCls");
						break;

					case 103:
						ZocFunction("ZocAsk('Please Enter Something')");
						break;

					default:
						goto DefProc;
				}
				rc= 0;
				break;

		case WM_PAINT: 
				{
					HDC hdc;
					PAINTSTRUCT paint;

					hdc= BeginPaint(hwnd, &paint);
					if (hdc) {
						RECT rect;
						HBRUSH hbrush;

						hbrush= CreateSolidBrush(RGB(0,0,128));
						if (hbrush) {
							GetClientRect(hwnd, &rect);
							FillRect(hdc, &rect, hbrush);
							DeleteObject(hbrush);
							hbrush= NULL;
						}
						EndPaint(hwnd, &paint);
						rc= TRUE;
					}
				}
				rc= 0;
				break;

		case WM_CLOSE: 
				DestroyWindow(hwnd);
				rc= 0;
				break;

		case WM_DESTROY:
				PostQuitMessage(0);
				rc= 0;
				break;

		default:
		DefProc:
				rc= DefWindowProc(hwnd, msg, wp, lp);
	}

	return rc;
}



////////////////////////////////////////////////////////////////////////////
//                                                                        //
// Connect to ZOC DDE wise                                                //
//                                                                        //
////////////////////////////////////////////////////////////////////////////
void 
InitDdeSession(void) 
{
	DWORD Result;
	HSZ Service;
	HSZ	Topic;

	DdeInst= 0;

	// Initialize a generic DDE session and check for errors
	Result= DdeInitialize(&DdeInst, (PFNCALLBACK)DdeCallback, MF_ERRORS, 0L);
	switch (Result) {

		case DMLERR_DLL_USAGE:
				MessageBox(hwMain,
						 "DDE-Connect failed (DMLERR_DLL_USAGE)!", 
						 AppName, MB_OK);
				return;

		case DMLERR_INVALIDPARAMETER:
				MessageBox(hwMain,
						 "DDE-Connect failed (DMLERR_INVALIDPARAMETER)!", 
						 AppName, MB_OK);
				return;

		case DMLERR_SYS_ERROR :
				MessageBox(hwMain,
						 "DDE-Connect failed (DMLERR_SYS_ERROR)!", 
						 AppName, MB_OK);
				return;
	}


	// do the real thing
	Service= DdeCreateStringHandle(DdeInst, "ZOC", CP_WINANSI);
	Topic= DdeCreateStringHandle(DdeInst, "COMM-DEBUG", CP_WINANSI);
	Conversation= DdeConnect(DdeInst, Service, Topic, NULL);
	if (Conversation==NULL) {
		DdeUninitialize(DdeInst);
		DdeInst= 0;
		MessageBox(hwMain, "Connection failed!", AppName, MB_OK);
	}
}



////////////////////////////////////////////////////////////////////////////
//                                                                        //
// ZocCommand() sends an EXECUTE style command to ZOC                     //
//                                                                        //
////////////////////////////////////////////////////////////////////////////
void 
ZocCommand(char * CmdStr) 
{
	char Cmd[256], Txt[256];
	DWORD Rc;

	strcpy(Cmd, CmdStr);
	DdeClientTransaction((LPBYTE)Cmd, (DWORD)strlen(Cmd), 
							Conversation, NULL, CF_TEXT, XTYP_EXECUTE, 1000, 
							&Rc);


	sprintf(Txt, "Transaction rc=0x%04x", Rc);
	MessageBox(hwMain, Txt, AppName, MB_OK);
}



////////////////////////////////////////////////////////////////////////////
//                                                                        //
// ZocFunction() sends an REQUEST style command to ZOC and gets the result//
//                                                                        //
////////////////////////////////////////////////////////////////////////////
void 
ZocFunction(char *CmdStr) 
{
	char Cmd[256], Txt[256];
	DWORD Rc;
	HSZ	Item; 
	HDDEDATA Result;

	Item= DdeCreateStringHandle(DdeInst, CmdStr, CP_WINANSI);
	Result= DdeClientTransaction(NULL, 0, Conversation, 
							Item, CF_TEXT, XTYP_REQUEST, 10000, 
							&Rc);

	sprintf(Txt, "Transaction rc=0x%04x\rData=", Rc);

	if (Result) {
		char *Data;
		DWORD Howmany;

		Data= DdeAccessData(Result, &Howmany);
		sprintf(Txt+strlen(Txt), "\"%s\"", Data);
		DdeUnaccessData(Result);
		Data= NULL;

		DdeFreeDataHandle(Result);
	}
	else {
		strcat(Txt, "<NO DATA>");
	}

	MessageBox(hwMain, Txt, AppName, MB_OK);
}





////////////////////////////////////////////////////////////////////////////
//                                                                        //
// EndDdeSession() closes our session                                     //
//                                                                        //
////////////////////////////////////////////////////////////////////////////
void 
EndDdeSession(void) 
{
	DdeDisconnect(Conversation);
	Conversation= NULL;

	DdeUninitialize(DdeInst);
	DdeInst= 0;
}
   


////////////////////////////////////////////////////////////////////////////
//                                                                        //
// This function is called whenever DDE wants to tell us something        //
//                                                                        //
////////////////////////////////////////////////////////////////////////////
HDDEDATA CALLBACK 
DdeCallback(UINT Type, UINT Format, HCONV hConv, HSZ Str1,
			HSZ Str2, HDDEDATA hData, DWORD Data1, DWORD Data2) 
{
	char *msg, *hdr= "DdeCallback()";
	HDDEDATA rc;

	if (Type & XCLASS_BOOL) {
		msg= "XCLASS_BOOL"; rc= 0;
	}
	else
	if (Type & XCLASS_DATA) {
		msg= "XCLASS_DATA"; rc= NULL;
	}
	else	
	if (Type & XCLASS_FLAGS) {
		msg= "XCLASS_FLAGS"; rc= DDE_FNOTPROCESSED;
	}
	else
	if (Type & XCLASS_NOTIFICATION) {
		msg= "XCLASS_NOTIFICATION"; rc= NULL;
	}
	else {
		msg= "????"; rc= 0;
	}

	MessageBox(hwMain, msg, hdr, MB_OK);
	return 0L;
}




