#define 	STRICT
#define	LIB

#include <windows.h>
#include <ddeml.h>
#include <stdio.h>

#define	MN_NOTIFICATION  		101
#define	MN_CLRSCR				102
#define	MN_QUIT					199

HINSTANCE	hInst;
HWND			hwMain;
char			AppName[] 	= "StdApp";
char			ClassName[] = "StdClass";
char			WndTitle[] 	= "StdWnd";

HCONV			Conversation;
DWORD 		DdeInst;


int	_stdcall 					WinMain (HINSTANCE, HINSTANCE, LPSTR, int);
LONG	  _stdcall 				MainWndProc (HWND, UINT, WORD, LONG);
HDDEDATA CALLBACK 			DdeCallback(UINT, UINT, HCONV, HSZ, HSZ, HDDEDATA, DWORD, DWORD);
void 								InitDdeSession(void);
void 								SendCmd(LPCSTR);
void 								EndDdeSession(void);


////////////////////////////////////////////////////////////////////////////////////////////////////
// WinMain()                                                                                      //
////////////////////////////////////////////////////////////////////////////////////////////////////

#pragma argsused

int	_stdcall WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
	{
	MSG        Message;
	WNDCLASS   WndClass;

	hInst = hInstance;

	if (!hPrevInstance)
		{
		WndClass.lpszClassName = ClassName;
		WndClass.hInstance     = hInst;
		WndClass.lpfnWndProc   = (WNDPROC)MainWndProc;
		WndClass.style         = CS_HREDRAW | CS_VREDRAW;
		WndClass.lpszMenuName  = (LPSTR)"MENU_1";
		WndClass.hCursor       = LoadCursor (NULL, IDC_ARROW);
		WndClass.hIcon         = NULL; //LoadIcon   (hInstance,(LPSTR)"ICON_1");
		WndClass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
		WndClass.cbClsExtra    = 0;
		WndClass.cbWndExtra    = 0;

		if (!RegisterClass (&WndClass))
			return 0;
		}

	hwMain = CreateWindow((LPSTR)ClassName,
								 (LPSTR)WndTitle,
								 WS_OVERLAPPEDWINDOW,
								 CW_USEDEFAULT,
								 CW_USEDEFAULT,
								 CW_USEDEFAULT,
								 CW_USEDEFAULT,
								 NULL,
								 NULL,
								 hInst,
								 NULL);

	if (!hwMain)
   	return NULL;

	// Hauptfenster ffnen:

	ShowWindow   (hwMain, SW_NORMAL);
	UpdateWindow (hwMain);

   // DDE-Sitzung starten:
   InitDdeSession();

	while (GetMessage ((LPMSG)&Message, NULL, 0, 0))
		{
		TranslateMessage ((LPMSG)&Message);
		DispatchMessage  ((LPMSG)&Message);
		}

	// DDE-Sitzung beenden
   EndDdeSession();

	return Message.wParam;
	}

////////////////////////////////////////////////////////////////////////////////////////////////////
// MainWndProc()                                                                                  //
////////////////////////////////////////////////////////////////////////////////////////////////////

LONG  _stdcall MainWndProc (HWND hWnd, UINT uiMsg, WORD wParam, LONG lParam)
	{
	switch (uiMsg)
		{
		case WM_SYSCOMMAND:
			{
			if (wParam == SC_CLOSE)
				{
				if (MessageBox (hWnd, (LPSTR)"Programm beenden ?",
									(LPSTR)AppName, MB_YESNO | MB_ICONQUESTION) == IDYES)
					DestroyWindow (hWnd);
				}
			else
				return (DefWindowProc (hWnd, uiMsg, wParam, lParam));
			}
		break;

		case WM_DESTROY:
			PostQuitMessage (0);
		break;

		case WM_COMMAND:
			{
			switch (wParam)
				{
				case MN_QUIT:
					if (MessageBox (hWnd, (LPSTR)"Programm beenden ?",
										(LPSTR)AppName, MB_YESNO | MB_ICONQUESTION) == IDYES)
						DestroyWindow (hWnd);
				break;

				case MN_NOTIFICATION:
            	SendCmd("ZocNotify('Hallo!')");
				break;

				case MN_CLRSCR:
            	SendCmd("ZocCls()");
				break;

				default:
					return DefWindowProc (hWnd, uiMsg, wParam, lParam);
				}
			}
		break;

		default:
			return (DefWindowProc (hWnd, uiMsg, wParam, lParam));
		}
	return 0L;
	}

////////////////////////////////////////////////////////////////////////////////////////////////////
// InitDdeSession() initiert eine DDE-Session                                                     //
////////////////////////////////////////////////////////////////////////////////////////////////////

void InitDdeSession(void)
	{
	DWORD 	Result;
	HSZ		Service;
	HSZ		Topic;

	DdeInst	 	= 0;

	// DDE-Sitzung aufbauen:
	Result = DdeInitialize(&DdeInst, (PFNCALLBACK)DdeCallback, MF_ERRORS, 0L);

	// Falls Fehler auftreten:
	switch (Result)
		{
		case DMLERR_DLL_USAGE:
			MessageBox(GetActiveWindow(), "DDE-Sitzung konnte nicht aufgebaut werden (DMLERR_DLL_USAGE)!", AppName, MB_OK);
			return;

		case DMLERR_INVALIDPARAMETER:
			MessageBox(GetActiveWindow(), "DDE-Sitzung konnte nicht aufgebaut werden (DMLERR_INVALIDPARAMETER)!", AppName, MB_OK);
			return;

		case DMLERR_SYS_ERROR :
			MessageBox(GetActiveWindow(), "DDE-Sitzung konnte nicht aufgebaut werden (DMLERR_SYS_ERROR)!", AppName, MB_OK);
			return;
		}

	// Verbindung zu ZOC herstellen:

	Service 		= DdeCreateStringHandle(DdeInst, "ZOC", CP_WINANSI);
	Topic			= DdeCreateStringHandle(DdeInst, "COMM-DEBUG", CP_WINANSI);
	Conversation = DdeConnect(DdeInst, Service, Topic, NULL);
	if (Conversation == NULL)
		{
		DdeUninitialize(DdeInst);
		MessageBox(GetActiveWindow(), "Die Verbindungsaufnahme mit ZOC ist fehlgeschlagen!", AppName, MB_OK);
		return;
		}
	}

////////////////////////////////////////////////////////////////////////////////////////////////////
// SendCmd() sendet einen Befehl an ZOC (Typ: EXECUTE).                                           //
////////////////////////////////////////////////////////////////////////////////////////////////////

void SendCmd(LPCSTR CmdStr)
	{
	char		Cmd[256];
	DWORD 	Result;

	strcpy(Cmd, CmdStr);
	DdeClientTransaction((LPBYTE)Cmd, (DWORD)strlen(Cmd),
								Conversation, NULL, CF_TEXT, XTYP_EXECUTE, 1000, &Result);

	if (Result == NULL)
		MessageBox(GetActiveWindow(), "Die Kommandobergabe an ZOC ist fehlgeschlagen!", AppName, MB_OK);
	}

////////////////////////////////////////////////////////////////////////////////////////////////////
// EndDdeSession() beendet eine DDE-Sitzung.                                                      //
////////////////////////////////////////////////////////////////////////////////////////////////////

void EndDdeSession(void)
	{
	DdeDisconnect(Conversation);
	DdeUninitialize(DdeInst);
	}
   
#pragma argsused

HDDEDATA CALLBACK DdeCallback(UINT Type, UINT Format, HCONV hConv, HSZ Str1,
										HSZ Str2, HDDEDATA hData, DWORD Data1, DWORD Data2)
	{
	if (Type & XCLASS_BOOL)
   	{
      MessageBox(GetActiveWindow(), "XCLASS_BOOL", "DdeCallBack()", MB_OK);
      return 0;
      }

	if (Type & XCLASS_DATA)
   	{
      MessageBox(GetActiveWindow(), "XCLASS_DATA", "DdeCallBack()", MB_OK);
      return NULL;
      }

	if (Type & XCLASS_FLAGS)
   	{
      MessageBox(GetActiveWindow(), "XCLASS_FLAGS", "DdeCallBack()", MB_OK);
      return DDE_FNOTPROCESSED;
      }

	if (Type & XCLASS_NOTIFICATION)
   	{
      MessageBox(GetActiveWindow(), "XCLASS_NOTIFICATION", "DdeCallBack()", MB_OK);
      return NULL;
      }

   MessageBox(GetActiveWindow(), "Sonstwas", "DdeCallBack()", MB_OK);
	return 0L;
	}



